[sn,nspk]=size(spike_time_record);
N_I=N_set;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if sn>N_set
    nspk = max(sum(spike_time_record(1:N_set,:)>0,2));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


sn = min(sn,N_I);


if sn>1
    ls_max=nspk;
    phi_obs=zeros(N_I,nspk);
    for nid = 1:sn-1
        s_driver = spike_time_record(nid,:);
        s_driver = s_driver(s_driver>0);
        T_driver = diff(s_driver);
        s_receiver = spike_time_record(nid+1,:);
        s_receiver = s_receiver(s_receiver>0);
        T_receiver = diff(s_receiver);
        if abs(length(s_receiver)-length(s_driver))>length(s_driver)*.2
            spk_fail=1;
        else
            spk_fail=0;
        end
        ls=min(length(s_driver),length(s_receiver));
        if (ls>1)
            phi_obs(nid,1:ls) = ((s_receiver(1:ls)-s_driver(1:ls))); %./T_driver(1:ls);
            %             phi_obs(nid,:) = phi_obs/T;
        else

            ls
            phi_obs =Inf;
            break
            %max_del_phi(nid) = Inf;
        end
    end
end

if spk_fail==1

    spk_fail_msg='spk_propagation_failed'

else


    if exist('phi_subplot') && exist('phi_segs_now_mod')
        fig_phi_T=figure;


        T_eff = diff(spike_time_record');

        T_eff = T_eff(:,1);
        valid=T_eff>0;
        T_eff = T_eff(valid)';


        [~,last_cycle]=size(phi_obs);
        tally = 1;
        for cid = 1:last_cycle-1

            if sum(phi_obs(1:N/2-1,cid)==Inf)>0
                plot(0,tally,'x');
                tally=tally+1;

            else

                phi_segs = phi_obs(1:N/2-1,cid)./T_eff(1);
                phi_segs_now_mod=mod(phi_segs,1);

                if sum(phi_segs_now_mod>0)>0
                    if cid>last_cycle/2
                        subplot(1,3,1), plot(phi_segs_now_mod);
                        hold on
                    else
                        subplot(1,3,1),plot(phi_segs_now_mod,'--');
                        hold on
                    end

                end

            end
        end
        g_last = g(end,:);
        axon_reach = sum(g_last>0)
        % legend(pl_phi)
        if noise_strength>0
            tt=title(['$T=$' num2str(T_eff(1)) '$I_{0}=$' num2str(I(1)) ' $ I_{1}=$' num2str((I(1)-I(2)) ),  ', $g_{max}=$' num2str(g_sample(gid)) ,'   $I_{II}=$' num2str(I(N/2+1)), ', $g_{chem}/g_{elec}$=' num2str(gc0_I)] );
        else
            tt=title(['$T=$' num2str(T_eff(1)) '$I_{0}=$' num2str(I(1)) ' $ I_{1}=$' num2str((I(1)-I(2)) ),  ', $g_{max}=$' num2str(g_sample(gid)) ,'  $I_{II}=$' num2str(I(N/2+1)),', $g_{chem}/g_{elec}$=' num2str(gc0_I)] );
        end
        xl=xlabel('seg #');
        %xlim([0,cycle_num])
        set(tt,'interpreter','latex','fontsize',15)
        yl=ylabel('$\phi$');
        set(yl,'interpreter','latex')
        ylim([0,max(0.05,max(phi_segs_now_mod))])
        legend


        for nid=1:N/2-1

            if phi_obs==Inf
                plot(ones(cycle_num,1),'--');

            else

                phi_obs_now = phi_obs(nid,valid)./T_eff;
                phi_obs_now_mod=mod(phi_obs_now,1);

                if sum(phi_obs_now_mod>0)>0
                    subplot(1,3,2)
                    pl_phi(nid) = plot(phi_obs_now_mod(phi_obs_now_mod>0));
                    color_phi = get(pl_phi(nid),'color');
                    hold on
                    subplot(1,3,2)

                    plot(phi_obs_now_mod(phi_obs_now_mod>0),'.','color',color_phi);

                else
                    pl_phi=[];
                end

            end
        end
        subplot(1,3,2)
        if isempty(ss_cyc)
            ss_msg='s.s. not reached';
            text(cycle_num,1,ss_msg )
            text(cycle_num,0.9,num2str(cv_phi));
        else
            text(ss_cyc,1, num2str(ss_cyc))
            text(ss_cyc,0.9,num2str(cv_phi'));
        end
        if isempty(sort_cyc)
            text(0,1,num2str(sort_cyc))
        else
            text(0,1,num2str(sort_cyc))
        end


        g_last = g(end,:);
        axon_reach = sum(g_last>0)
        % legend(pl_phi)
        if noise_strength>0
            tt=title(['$T=$' num2str(T_eff(1)) '$I_{0}=$' num2str(I(1)) ' $ I_{1}=$' num2str((I(1)-I(2))/g_sample ),  ', $g_{max}=$' num2str(g_sample(gid)) ,'   $I_{II}=$' num2str(I(N/2+1)), ', $g_{chem}/g_{elec}$=' num2str(gc0_I*s_amp_sample/g_sample) '  hetero=' num2str(noise_strength)] );
        else
            tt=title(['$T=$' num2str(T_eff(1)) '$I_{0}=$' num2str(I(1)) ' $ I_{1}=$' num2str((I(1)-I(2))/g_sample ),  ', $g_{max}=$' num2str(g_sample(gid)) ,'  $I_{II}=$' num2str(I(N/2+1)),', $g_{chem}/g_{elec}$=' num2str(gc0_I*s_amp_sample/g_sample)] );
        end
        xl=xlabel('cycle #');
        %xlim([0,cycle_num])
        set(tt,'interpreter','latex','fontsize',15)
        yl=ylabel('$\phi$');
        set(yl,'interpreter','latex')
        ylim([0,1])
        text(length(phi_obs_now_mod)/2,0.5,num2str(syn_delay))
        text(length(phi_obs_now_mod)/2+1,0.5,num2str(I(N/2+1:end,:)))



        subplot(1,3,3)
        unit_size = floor(N/2/4);

        for u_size =unit_size:-1:1
            tally = 1;
            last_unit_num=N/2/u_size-1;
            for cid = 1:last_cycle-1

                if sum(phi_obs(1:N/2-1,cid)==Inf)>0
                    plot(0,tally,'x');
                    tally=tally+1;

                else

                    phi_segs = phi_obs(1:N/2-1,:)./T_eff(1);
                    phi_segs_mod=mod(phi_segs,1);
                    phi_unit=cell(1);
                    for uid = 1:floor(last_unit_num)
                        phi_unit{uid} = sum(phi_segs_mod((uid-1)*u_size+1:uid*u_size,:));
                        [~,last_unit_cycle(uid)] = size(phi_unit{uid});% each class phi(cycle) for units
                    end

                    last_unit_cycle=min(last_unit_cycle);

                    for ccid =1:last_unit_cycle
                        for uid = 1:floor(last_unit_num)

                            phi_unit_record(uid,ccid)=phi_unit{uid}(ccid);

                        end
                    end


                    %             subplot(1,3,3)

                    %             for uid = 1:floor(last_unit_num)
                    %                plot(phi_unit_record(uid,:))
                    %                hold on
                    %             end



                end
            end


            [~,lc]=size(phi_unit_record);
            lc = max(1,lc-2);
            unit_score(u_size)=var(phi_unit_record(:,lc));
            clear phi_unit_record
            %

        end

        [~,best_unit_size] = min(unit_score);

        for u_size =best_unit_size
            tally = 1;
            last_unit_num=N/2/u_size-1;
            for cid = 1:last_cycle-1

                if sum(phi_obs(1:N/2-1,cid)==Inf)>0
                    plot(0,tally,'x');
                    tally=tally+1;

                else

                    phi_segs = phi_obs(1:N/2-1,:)./T_eff(1);
                    phi_segs_mod=mod(phi_segs,1);
                    phi_unit=cell(1);
                    for uid = 1:floor(last_unit_num)
                        phi_unit{uid} = sum(phi_segs_mod((uid-1)*u_size+1:uid*u_size,:));
                        [~,last_unit_cycle(uid)] = size(phi_unit{uid});% each class phi(cycle) for units
                    end

                    last_unit_cycle=min(last_unit_cycle);

                    for ccid =1:last_unit_cycle
                        for uid = 1:floor(last_unit_num)

                            phi_unit_record(uid,ccid)=phi_unit{uid}(ccid);

                        end
                    end




                end
            end

            %     unit_score(u_size)=var(phi_unit_record(:,lc));
        end


        [~,lc]=size(phi_unit_record);
        lc = max(1,lc-2);

        subplot(1,3,3)
        for uid = 1:floor(last_unit_num)
            plot(phi_unit_record(uid,1:lc))
            hold on
        end



        subplot(1,3,3)
        hold on
        tell_best_unit=['best unit size:' num2str(best_unit_size)];
        tb=text(0,0.05,tell_best_unit);
        set(tb,'fontsize',20)
        xlabel('cycle')
        legend
        %  clear phi_unit_record
        % %

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    else
        T_eff = diff(spike_time_record');

        T_eff = T_eff(:,1);
        valid=T_eff>0;
        T_eff = T_eff(valid)';
        figure;
        [~,last_cycle]=size(phi_obs);
        tally = 1;
        for cid = 1:last_cycle-1

            if sum(phi_obs(1:N/2-1,cid)==Inf)>0
                plot(0,tally,'x');
                tally=tally+1;

            else

                phi_segs = phi_obs(1:N/2-1,cid)./T_eff(1);
                phi_segs_now_mod=mod(phi_segs,1);


                if sum(phi_segs_now_mod>0)>0
                    if cid>last_cycle/2
                        plot(phi_segs_now_mod);
                        hold on
                    else
                        plot(phi_segs_now_mod,'--');
                        hold on
                    end

                end

            end
        end
        g_last = g(end,:);
        axon_reach = sum(g_last>0)
        % legend(pl_phi)

        tt=title(['$T=$' num2str(T_eff(1)) '$I_{0}=$' num2str(I(1)) ' $ I_{1}=$' num2str((I(1)-I(2)) ),  ', $g_{0}=$' num2str(g0) ,'  $I_{II}=$' num2str(I(N/2+1)),', $g_{c0}$=' num2str(gc0_I)] );

        xl=xlabel('seg #');
        %xlim([0,cycle_num])
        set(tt,'interpreter','latex','fontsize',15)
        yl=ylabel('$\phi$');
        set(yl,'interpreter','latex')
        if exist('phi_segs_now_mod')
            if max(phi_segs_now_mod)>0
                ylim([0,max(phi_segs_now_mod)])
            end
        end
        legend
        figure;


        for nid=1:N/2-1

            if phi_obs==Inf
                plot(ones(cycle_num,1),'--');

            else

                phi_obs_now = phi_obs(nid,valid)./T_eff;
                phi_obs_now_mod=mod(phi_obs_now,1);

                if sum(phi_obs_now_mod>0)>0
                    pl_phi(nid) = plot(phi_obs_now_mod(phi_obs_now_mod>0));
                    color_phi = get(pl_phi(nid),'color');
                    hold on
                    plot(phi_obs_now_mod(phi_obs_now_mod>0),'.','color',color_phi);
                    %                         plot(phi_obs_now_mod(phi_obs_now_mod>0)+1,'color',color_phi)
                    %                         plot(phi_obs_now_mod(phi_obs_now_mod>0)-1,'color',color_phi)
                else
                    pl_phi=[];
                end

            end
        end
        g_last = g(end,:);
        axon_reach = sum(g_last>0)
        % legend(pl_phi)

        tt=title(['$T=$' num2str(T_eff(1)) '$I_{0}=$' num2str(I(1)) ' $ I_{1}=$' num2str((I(1)-I(2)) ),  ', $g_{0}=$' num2str(g0) ,'  $I_{II}=$' num2str(I(N/2+1)),', $g_{c0}$=' num2str(gc0_I)] );
        xl=xlabel('cycle #');
        %xlim([0,cycle_num])
        set(tt,'interpreter','latex','fontsize',15)
        yl=ylabel('$\phi$');
        set(yl,'interpreter','latex')
        ylim([0,1])

    end

end
