function SetParameters(n,g_g,g_c,g_c_II,I_I,DeltaI,I_II,epsilon)
% SET PARAMETERS FOR THE MODEL
global N_set  g0all gc0all gc0_II epsil 
N_set = n;          % Number of segments

% SYNAPTIC STRENGTH
g0all   =   g_g;        % g_g
gc0all  =   g_c;        % g_c
gc0_II  =   g_c_II;     % g_c_II

% BIAS CURRENT
global I0_ref I1_fix I2_now
I0_ref  =   I_I;        % I_I BIAS CURRENT OF LEADER NEURON
I1_fix  =   DeltaI;     % DeltaI
I2_now  =   I_II;       % I_II

%% Asymptotic parameter
epsil = epsilon;          % epsilon

% %%
% n_first = ceil(N_set/2+1);
% type_II_toggle = 1;
% ax_range_II = 1;
% eps_bk =1;
% %% SIMULATION PARAMETERS
% % global fail_neuron_num fail_rate
% % % fail_neuron_num = 9:16;  %????
% fail_rate = 0;
% random_init = 1;
% rep_num = 1;
% init_assign = 0;
% rep_sort_num = 3;
% sorting_check= 1;

global I
I = SetBiasCurr(I0_ref,I1_fix,I2_now,epsil,N_set*2);


end

function I = SetBiasCurr(I0_ref,I1_fix,I2_now,epsil,N)
%% SET bias current for V2a-I
I           =ones(N,1);
I1_fix      = epsil*I1_fix;% rescale O(epsilon^1) parameters
I(1)        = I0_ref;
Ifollow     = I0_ref + I1_fix; % change this to + if we want to keep it consistent
I(2:N)      = Ifollow*ones(N-1,1);
% Set bias current for V2a-II
I(N/2+1:end)    = I2_now;
end

