function [G_g,G_c] = constructMatrix_gg_gc(g0,s_amp_II_I,s_amp_I_II,ax_range_II)
global N 
f_dir           =   -1; % +1 for ascending axons 
g_inter_sample  =   0; % gap junction btw type I and II's used to construct the matrix g
s_amp           =   1; 
%% Build g_c matrix and g_g matrix ~ line 376
        type_I = [ones(N/2,1);zeros(N/2,1)];
        s_II_I1 = s_amp_II_I*diag(type_I,N/2+f_dir); % From type II's to type I, only first N/2 neurons get it
        s_II_I1 = s_II_I1(1:N,1:N);
        s_II_I1(1,N/2)=0;
        if exist('ax_range_II')
            s_II_I = s_amp_II_I*diag(type_I,N/2+f_dir*ax_range_II); % From type II's to type I, only first N/2 neurons get it
            s_II_I = s_II_I(1:N,1:N);
            s_II_I(1:N/2,1:N/2)=0;

            s_II_I(2:ax_range_II,N/2+1)=s_amp_II_I; % might need to change this part if we want to  try fb
            if exist('fb_switch')
                s_II_I(2:ax_range_II,N/2+1)=0; % might need to change this part if we want to  try fb
            end
            %         for aaid = 2:ax_range_II
            %         s_II_I(aaid,N/2+aaid)=s_amp_II_I;
            %         end
        else
            s_II_I = s_amp_II_I*diag(type_I,N/2+f_dir); % From type II's to type I, only first N/2 neurons get it
            s_II_I = s_II_I(1:N,1:N);
            s_II_I(1,N/2)=0;
        end
        cov_twice = (s_II_I==s_II_I1).*(s_II_I>0);
        s_II_I= s_II_I+s_II_I1-s_amp_II_I*cov_twice;
        %     s_II_I(N/2+1,1)=s_amp_I_II;
        %     s_II_I = s_II_I
        %s_II_I(N/2,end)=s_amp_II_I;
        g_II_I = diag(type_I,N/2+1); % From type II's to type I, only first N/2 neurons get it
        g_II_I = g_II_I(1:N,1:N);
        %     g_II_I(1,N/2)=0;
        type_II = s_amp_I_II*[zeros(N/2,1);ones(N/2,1)];
        s_I_II = diag(type_II,-N/2-1);
        s_I_II = s_I_II((end-N+1):end,(end-N+1):end);

        %%%%%%%%%%%%%%
        %%%%%%%%%%%%%%
        if exist('no_staggering')
            type_II = s_amp_I_II*[zeros(N/2,1);ones(N/2,1)];
            s_I_II = diag(type_II,-N/2);
            s_I_II = s_I_II((end-N+1):end,(end-N+1):end);
        end
        %%%%%%%%%%%%%%
        %% to get rid of Boundary effect
        %%%%%%%%%%%%%%
        s_I_II(N/2+1,1)=s_amp_I_II;

%         % if we want to include the boundary effect
%         if exist('boundary_effect')
%             s_I_II(N/2+1,1)=0;
%         end
  
        s_mat = s_II_I+s_I_II;
        s_mat = s_mat(1:N,1:N);
        %%
  
        g_I_II=0*s_I_II;
        %     g_I_II=0*g_I_II
        g_inter = g_I_II+g_II_I;
        g_inter=0*g_inter;
        g_inter=g_inter_sample*g_inter;
        %% Construct matrix of g_g
        g= zeros(N,N);
        g_I = g0*diag(type_I,-1);
        g_I = g_I(1:N/2,1:N/2);
        g(1:N/2,1:N/2)=g_I;


        % if you want the length of ascending connection to be greater than one
%         if (ax_chem)
%             for ax_id = 2:ax_len_sample(aid)
%                 s_seg_t = diag(ones(N,1),ax_id);
%                 %s_seg_b = diag(ones(N,1),-ax_id);
%                 s_mat = s_mat(1:N,1:N)+s_seg_t(1:N,1:N);%+s_seg_b(1:N,1:N);
%             end
%         end
%         total_g=sum(g,2)
%         total_g(total_g==0) = 1;
%         g_tot = diag(1./total_g)
% 
%         g= g_tot*g;

        %     g= g_sample*g;

        g= g+g_inter;
        s_mat = s_amp*s_mat;

        G_g = g;
        G_c = s_mat;
end

